<?php

// /USR/SBIN/CRON[9741]: (root) CMD (   cd / && run-parts --report /etc/cron.hourly)
$messages[] = array('|^\(root\) CMD |U', 'cron');

// /usr/sbin/cron[3372]: (CRON) INFO (Running @reboot jobs)
// /usr/sbin/cron[3372]: (CRON) STARTUP (fork ok)
// /usr/sbin/cron[3371]: (CRON) INFO (pidfile fd = 3)
$messages[] = array('|^\(CRON\) |U', 'cron');

function callback_cron($data) {
 $legit = array();
 $legit[] = '(root) CMD (   cd / && run-parts --report /etc/cron.hourly)';

 if (
  in_array($data['message'], $legit) &&
  preg_match('|^/USR/SBIN/CRON[\d+]$', $data['message'])
 )
  return array(
   'level' => LEVEL_NOTICE,
   'name' => 'Hourly cron run.',
   'description' => 'A full dump follows: '.print_r($data, TRUE)
  );

 $startup = array();
 $startup[] = '(CRON) INFO (Running @reboot jobs)';
 $startup[] = '(CRON) STARTUP (fork ok)';
 $startup[] = '(CRON) INFO (pidfile fd = 3)'; // is always file descriptor 3?

 if (
  in_array($data['message'], $startup) &&
  preg_match('|^/usr/sbin/cron[\d+]$', $data['message'])
 )
  return array(
   'level' => LEVEL_NOTICE,
   'name' => 'Cron startup.',
   'description' => 'A full dump follows: '.print_r($data, TRUE)
  );

 return array(
  'level' => LEVEL_CRITICAL,
  'name' => 'Anomaly detected in CRON judge!',
  'description' => 'A full dump follows: '.print_r($data, TRUE)
 );
}

?>
