<?php

$messages[] = array('|^grsec: exec of |U', 'grsec_exec');
$messages[] = array('|^grsec: chdir to |U', 'grsec_chdir');
$messages[] = array('|^grsec: shared memory of |U', 'grsec_shared');
$messages[] = array('|^grsec: time set by |U', 'grsec_time');
$messages[] = array('|^grsec: semaphore |U', 'grsec_semaphore');

$regexpr['grsec']['path'] = '.*';
$regexpr['grsec']['command'] = '.*';
$regexpr['grsec']['process_id'] = '.*';
$regexpr['grsec']['process_name'] = '.*';
$regexpr['grsec']['uid'] = '.*';
$regexpr['grsec']['gid'] = '.*';
$regexpr['grsec']['size'] = '.*'; // memory size

$callrex = &$regexpr['grsec'];

// grsec: exec of /usr/bin/php5 (php /home/x/Desktop/lollobox/judge/judge.php ) by /bin/bash[bash:5509] uid/euid:0/0 gid/egid:0/0, parent /bin/bash[bash:4845] uid/euid:0/0 gid/egid:0/0
$regexpr['grsec']['exec'] = 
 '/^grsec: exec of ('.$callrex['path'].') '.
 '\(('.$callrex['command'].')\) '.
 'by ('.$callrex['path'].')\[('.$callrex['process_name'].'):('.$callrex['process_id'].')\] '.
 'uid\/euid:('.$callrex['uid'].')\/('.$callrex['uid'].') '.
 'gid\/egid:('.$callrex['gid'].')\/('.$callrex['gid'].'), '.
 'parent ('.$callrex['path'].')\[('.$callrex['process_name'].'):('.$callrex['process_id'].')\] '.
 'uid\/euid:('.$callrex['uid'].')\/('.$callrex['uid'].') '.
 'gid\/egid:('.$callrex['gid'].')\/('.$callrex['gid'].')$/U';

// grsec: shared memory of size 393216 created by /usr/bin/gedit[gedit:10171] uid/euid:1000/1000 gid/egid:1000/1000, parent /sbin/init[init:1] uid/euid:0/0 gid/egid:0/0
$regexpr['grsec']['shared'] = 
 '/^grsec: shared memory of size ('.$callrex['size'].') '.
 'created by ('.$callrex['path'].')\[('.$callrex['process_name'].'):('.$callrex['process_id'].')\] '.
 'uid\/euid:('.$callrex['uid'].')\/('.$callrex['uid'].') '.
 'gid\/egid:('.$callrex['gid'].')\/('.$callrex['gid'].'), '.
 'parent ('.$callrex['path'].')\[('.$callrex['process_name'].'):('.$callrex['process_id'].')\] '.
 'uid\/euid:('.$callrex['uid'].')\/('.$callrex['uid'].') '.
 'gid\/egid:('.$callrex['gid'].')\/('.$callrex['gid'].')$/U';

// grsec: chdir to /home/x/.local/share/autopackage-gtk by /usr/bin/find[find:6361] uid/euid:1000/1000 gid/egid:1000/1000, parent /bin/bash[bash:6202] uid/ euid:1000/1000 gid/egid:1000/1000
$regexpr['grsec']['chdir'] = 
 '/^grsec: chdir to ('.$callrex['path'].') '.
 'by ('.$callrex['path'].')\[('.$callrex['process_name'].'):('.$callrex['process_id'].')\] '.
 'uid\/euid:('.$callrex['uid'].')\/('.$callrex['uid'].') '.
 'gid\/egid:('.$callrex['gid'].')\/('.$callrex['gid'].'), '.
 'parent ('.$callrex['path'].')\[('.$callrex['process_name'].'):('.$callrex['process_id'].')\] '.
 'uid\/euid:('.$callrex['uid'].')\/('.$callrex['uid'].') '.
 'gid\/egid:('.$callrex['gid'].')\/('.$callrex['gid'].')$/U';

// grsec: time set by /usr/sbin/rdate[rdate:4639] uid/euid:0/0 gid/egid:0/0, parent /etc/cron.daily/rdate[rdate:4638] uid/euid:0/0 gid/egid:0/0
$regexpr['grsec']['time'] = 
 '/^grsec: time set '.
 'by ('.$callrex['path'].')\[('.$callrex['process_name'].'):('.$callrex['process_id'].')\] '.
 'uid\/euid:('.$callrex['uid'].')\/('.$callrex['uid'].') '.
 'gid\/egid:('.$callrex['gid'].')\/('.$callrex['gid'].'), '.
 'parent ('.$callrex['path'].')\[('.$callrex['process_name'].'):('.$callrex['process_id'].')\] '.
 'uid\/euid:('.$callrex['uid'].')\/('.$callrex['uid'].') '.
 'gid\/egid:('.$callrex['gid'].')\/('.$callrex['gid'].')$/U';

// grsec: semaphore of uid:1000 euid:1000 removed by /usr/lib/iceweasel/firefox-bin[firefox-bin:4517] uid/euid:1000/1000 gid/egid:1000/1000, parent /sbin/init[init:1] uid/euid:0/0 gid/egid:0/0
$regexpr['grsec']['semaphore']['removed'] = 
 '/^grsec: semaphore of '.
 'uid:('.$callrex['uid'].') euid:('.$callrex['uid'].') '.
 'removed by ('.$callrex['path'].')\[('.$callrex['process_name'].'):('.$callrex['process_id'].')\] '.
 'uid\/euid:('.$callrex['uid'].')\/('.$callrex['uid'].') '.
 'gid\/egid:('.$callrex['gid'].')\/('.$callrex['gid'].'), '.
 'parent ('.$callrex['path'].')\[('.$callrex['process_name'].'):('.$callrex['process_id'].')\] '.
 'uid\/euid:('.$callrex['uid'].')\/('.$callrex['uid'].') '.
 'gid\/egid:('.$callrex['gid'].')\/('.$callrex['gid'].')$/U';

// grsec: semaphore created by /usr/lib/iceweasel/firefox-bin[firefox-bin:4517] uid/euid:1000/1000 gid/egid:1000/1000, parent /sbin/init[init:1] uid/euid:0/0 gid/egid:0/0
$regexpr['grsec']['semaphore']['created'] = 
 '/^grsec: time set '.
 'by ('.$callrex['path'].')\[('.$callrex['process_name'].'):('.$callrex['process_id'].')\] '.
 'uid\/euid:('.$callrex['uid'].')\/('.$callrex['uid'].') '.
 'gid\/egid:('.$callrex['gid'].')\/('.$callrex['gid'].'), '.
 'parent ('.$callrex['path'].')\[('.$callrex['process_name'].'):('.$callrex['process_id'].')\] '.
 'uid\/euid:('.$callrex['uid'].')\/('.$callrex['uid'].') '.
 'gid\/egid:('.$callrex['gid'].')\/('.$callrex['gid'].')$/U';

function callback_grsec_exec($data) {
 global $regexpr;
 if (DEBUG) debug('Called '.__FUNCTION__, $data);

 preg_match_all($regexpr['grsec']['exec'], $data['message'], $parsed);
 if (DEBUG && DEBUG_VERBOSE) debug(__FUNCTION__.'() $parsed', $parsed);

 if (count($parsed) == 17) {
  $exec = $parsed[1][0];
  $command = $parsed[2][0];
  $by = $parsed[3][0];
  $by_process_name = $parsed[4][0];
  $by_process_id = $parsed[5][0];
  $by_uid = $parsed[6][0];
  $by_euid = $parsed[7][0];
  $by_gid = $parsed[8][0];
  $by_egid = $parsed[9][0];
  $parent = $parsed[10][0];
  $parent_process_name = $parsed[11][0];
  $parent_process_id = $parsed[12][0];
  $parent_uid = $parsed[13][0];
  $parent_euid = $parsed[14][0];
  $parent_gid = $parsed[15][0];
  $parent_egid = $parsed[16][0];

  // absolutly bad paths to execute commands
  $badpaths = array();
  $badpaths[] = '/tmp/';
  $badpaths[] = '/dev/shm/';

  foreach ($badpaths as $badpath)
   if (preg_match('|^'.$badpath.'|U', $exec))
    return array(
     'level' => LEVEL_CRITICAL,
     'name' => 'An executable has been called in a TOTALLY UNTRUSTED path!',
     'description' => 'Executable('.$exec.') with command('.$command.').'
    );

  // management and suid commands 
  $specials = array();
  $specials[] = '/usr/bin/passwd';

  if (in_array($exec, $specials))
   return array(
    'level' => LEVEL_CRITICAL,
    'name' => 'A very special command has been executed!',
    'description' => 'A full dump follows: '.print_r($data, TRUE)
   );

  // interpterets are a known way to escape/abuse tpe
  $interpreters = array();
  $interpreters[] = '/usr/bin/php5';
  $interpreters[] = '/usr/bin/python2.4';
  $interpreters[] = '/usr/bin/perl';

  $interactive_php = array();
  $interactive_php[] = 'php '; 
  $interactive_php[] = 'php -a '; // fix bypass
  $interactive_php[] = 'php -f '; // fix bypass

  if (in_array($exec, $interpreters)) {
   if ($exec == '/usr/bin/php5') {
    if (in_array($command, $interactive_php)) 
     return array(
      'level' => LEVEL_CRITICAL,
      'name' => 'Somebody called the PHP interpreter in interactive mode!',
      'description' => 'Interpreter('.$exec.') with command('.$command.').'
     );
   } else
    return array(
     'level' => LEVEL_WARNING,
     'name' => 'Somebody called an interpreter!',
     'description' => 'Interpreter('.$exec.') with command('.$command.').'
    );
  }

  // this is a blacklist sentry (eg it looks for sensitive words)
  $sensitives = array();
  $sensitives[] = '/etc/passwd';
  $sensitives[] = '/etc/shadow';

  foreach ($sensitives as $sensitive)
   if (preg_match('|'.$sensitive.'|U', $command))
    return array(
     'level' => LEVEL_WARNING,
     'name' => 'A command involves a sensitive target!',
     'description' => 'Executable('.$exec.') with command('.$command.').'
    );

  // whitelist root executing commands in /root
  // if ($by_uid == 0 && preg_match('|^/root/|U', $exec))
  //  return array(
  //   'level' => LEVEL_NOTICE,
  //   'name' => 'Root executing a command in its home.',
  //   'description' => 'Executable('.$exec.') with command('.$command.').'
  //  );

  // whitelist commands in user homes
  $users = array();
  $users[] = array(0, '/root/');
  $users[] = array(1000, '/home/x/');

  foreach ($users as $user)
   if ($by_uid == $user[0] && preg_match('|^'.$user[1].'|U', $exec))
    return array(
     'level' => LEVEL_NOTICE,
     'name' => 'A user executing a command in its home.',
     'description' => 'Executable('.$exec.') with command('.$command.').'
    ); 

  // this implements a tpe like feature
  $safepaths = array();
  $safepaths[] = '/bin/';
  $safepaths[] = '/sbin/';
  $safepaths[] = '/usr/bin/';
  $safepaths[] = '/usr/sbin/';
  $safepaths[] = '/etc/init.d/';
  $safepaths[] = '/etc/dbus-1/event.d/';
  $safepaths[] = '/usr/lib/hal/';
  $safepaths[] = '/usr/lib/gnome-panel/';
  $safepaths[] = '/usr/lib/gnome-applets/';

  foreach ($safepaths as $safepath)
   if (preg_match('|^'.$safepath.'|U', $exec))
    return array(
     'level' => LEVEL_NOTICE,
     'name' => 'An executable has been called in a trusted path.',
     'description' => 'Executable('.$exec.') with command('.$command.').'
    );

  // this implements a tpe like feature for binaries
  $safebins = array();
  $safebins[] = '/etc/rc.local';
  $safebins[] = '/etc/gdm/Init/Default';
  $safebins[] = '/usr/lib/gdm/gdmgreeter';
  $safebins[] = '/etc/gdm/PreSession/Default';
  $safebins[] = '/etc/gdm/Xsession';
  $safebins[] = '/usr/lib/gcc/i486-linux-gnu/4.1.2/cc1';
  $safebins[] = '/usr/lib/gcc/i486-linux-gnu/4.1.2/collect2';
  $safebins[] = '/usr/lib/libgconf2-4/gconfd-2';
  $safebins[] = '/usr/lib/libgconf2-4/gconf-sanity-check-2';
  $safebins[] = '/usr/lib/bonobo-activation/bonobo-activation-server';
  $safebins[] = '/usr/lib/control-center/gnome-settings-daemon';
  $safebins[] = '/usr/lib/gnome-vfs-2.0/gnome-vfs-daemon';
  $safebins[] = '/usr/lib/nautilus-cd-burner/mapping-daemon';
  $safebins[] = '/usr/lib/iceweasel/iceweasel';
  $safebins[] = '/usr/lib/iceweasel/firefox-bin';
  $safebins[] = '/usr/lib/icedove/run-mozilla.sh';
  $safebins[] = '/usr/lib/icedove/icedove-bin';
  // $safebins[] = '/usr/lib/hal/hald-runner';
  $safebins[] = '/usr/share/lighttpd/create-mime.assign.pl';
  $safebins[] = '/usr/share/lighttpd/include-conf-enabled.pl';
  $safebins[] = '/usr/lib/php5/maxlifetime';
  $safebins[] = '/usr/lib/man-db/man';

  foreach ($safebins as $safebin)
   if (preg_match('|^'.$safebin.'|U', $exec))
    return array(
     'level' => LEVEL_NOTICE,
     'name' => 'The called executable is truested.',
     'description' => 'Executable('.$exec.') with command('.$command.').'
    );

  // privileged users executing in user homes, user ids start at 1000
  if (
   preg_match('|^/home/|U', $exec) &&
   $by_uid < 999
  )
   return array(
    'level' => LEVEL_CRITICAL,
    'name' => 'An executable has been called in a POTENTIALLY UNTRUSTED path!',
    'description' => 'Executable('.$exec.') with command('.$command.').'
   );
 } else
  trigger_error('Malformed grsec exec log!', E_USER_WARNING);

 return array(
  'level' => LEVEL_CRITICAL,
  'name' => 'Anomaly detected in Grsec exec judge!',
  'description' => 'A full dump follows: '.print_r($data, TRUE)
 );
}

function callback_grsec_shared($data) {
 return array(
  'level' => LEVEL_NOTICE,
  'name' => 'Shared memory operations',
  'description' => 'A full dump follows: '.print_r($data, TRUE)
 );
}

function callback_grsec_chdir($data) {
 global $regexpr;
 if (DEBUG) debug('Called '.__FUNCTION__, $data);

 preg_match_all($regexpr['grsec']['chdir'], $data['message'], $parsed);
 if (DEBUG) debug(__FUNCTION__.'() $parsed', $parsed);

 if (count($parsed) == 16) {
  $chdir = $parsed[1][0];
  $by = $parsed[2][0];
  $by_process_name = $parsed[3][0];
  $by_process_id = $parsed[4][0];
  $by_uid = $parsed[5][0];
  $by_euid = $parsed[6][0];
  $by_gid = $parsed[7][0];
  $by_egid = $parsed[8][0];
  $parent = $parsed[9][0];
  $parent_process_name = $parsed[10][0];
  $parent_process_id = $parsed[11][0];
  $parent_uid = $parsed[12][0];
  $parent_euid = $parsed[13][0];
  $parent_gid = $parsed[14][0];
  $parent_egid = $parsed[15][0];

  // skip chdir checks for root
  if ($by_uid == '0')
   return array(
    'level' => LEVEL_NOTICE,
    'name' => 'Root is not checked for chdirs.',
    'description' => 'Chdir('.$chdir.') by('.$by.').'
   );

  // whitelist cd in user homes
  $users = array();
  $users[] = array(0, '/root/');
  $users[] = array(0, '/root'); // TODO: dam trailing slashes, could be a security hole but / is not user controlled
  $users[] = array(1000, '/home/x/');
  $users[] = array(1000, '/home/x'); // TODO: dam trailing slashes, a user in /home/pippo_pluto bypass this check in /home/pippo

  foreach ($users as $user)
   if ($by_uid == $user[0] && preg_match('|^'.$user[1].'|U', $chdir))
    return array(
     'level' => LEVEL_NOTICE,
     'name' => 'A user made a chdir in its home.',
     'description' => 'Chdir('.$chdir.') by('.$by.').'
    );

 } else
  trigger_error('Malformed grsec chdir log!', E_USER_WARNING);

 return array(
  'level' => LEVEL_CRITICAL,
  'name' => 'Anomaly detected in Grsec chdir judge!',
  'description' => 'A full dump follows: '.print_r($data, TRUE)
 );
}

function callback_grsec_time($data) {
 return array(
  'level' => LEVEL_CRITICAL,
  'name' => 'Time has been changed!',
  'description' => 'A full dump follows: '.print_r($data, TRUE)
 );
}

function callback_grsec_semaphore($data) {
 // $regexpr['grsec']['semaphore']['created']
 // $regexpr['grsec']['semaphore']['removed']
 // todo

 return array(
  'level' => LEVEL_NOTICE,
  'name' => 'A semaphore has been created or deleted.',
  'description' => 'Executable('.$exec.') with command('.$command.').'
 );
}

?>
