<?php

function input($logpipe, $output_handle) {
 // todo: implement this check for named pipes
 // if (file_exists($logpipe) || is_readable($logpipe)) 
 //  trigger_error('Check the logpipe please!', E_USER_ERROR);

 $handle = fopen($logpipe, 'r');
 if ($handle) {
  $line = '';
  while (!feof($handle)) {
   $buffer = fgets($handle, MAXLINE);
   if (DEBUG) debug(__FUNCTION__.'$buffer', $buffer);
   if ($buffer[strlen($buffer)-1] == "\n") {
    if (DEBUG && DEBUG_VERBOSE) debug(__FUNCTION__.'$buffer', 'is newline terminated, calling judgeline()');
    judgeline($line.$buffer, $output_handle); // needs & ?
    $line = '';
   } else {
    if (DEBUG && DEBUG_VERBOSE) debug(__FUNCTION__.'$buffer', 'is not a complete line');
    $line .= $buffer;
   }
  }
  fclose($handle);
 } else
  trigger_error('Serius problem reading from the pipe!', E_USER_ERROR);
}

function judgeline($logline, $output_handles) {
 global $regexpr, $messages, $months;

 if (DEBUG && DEBUG_VERBOSE) debug('$regexpr[\'syntax\']', $regexpr['syntax']);
 preg_match_all($regexpr['syntax'], $logline, $parsed);
 if (DEBUG && DEBUG_VERBOSE) debug(__FUNCTION__.'$parsed', $parsed);

 if (count($parsed) == 9 &&
  isset($parsed[0]) && isset($parsed[0][0]) && // full line
  isset($parsed[1]) && isset($parsed[1][0]) && // month
  isset($parsed[2]) && isset($parsed[2][0]) && // day
  isset($parsed[3]) && isset($parsed[3][0]) && // hour
  isset($parsed[4]) && isset($parsed[4][0]) && // minute
  isset($parsed[5]) && isset($parsed[5][0]) && // second
  isset($parsed[6]) && isset($parsed[6][0]) && // hostname
  isset($parsed[7]) && isset($parsed[7][0]) && // source
  isset($parsed[8]) && isset($parsed[8][0]) // message
 ) {
  $parsed[1][0] = $months[$parsed[1][0]];
  foreach ($messages as $message) {
   if (DEBUG) debug(__FUNCTION__.'() $message[0]', $message[0]);
   if (preg_match($message[0], $parsed[8][0])) {
    $callback = 'callback_'.$message[1];

    if (!function_exists($callback))
     trigger_error('Missing callback('.$callback.')!', E_USER_WARNING);
    else {
     $judge = $callback(array(
      'full_line' => $parsed[0][0],
      'month' => $parsed[1][0],
      'day' => $parsed[2][0],
      'hour' => $parsed[3][0],
      'minute' => $parsed[4][0],
      'second' => $parsed[5][0],
      'hostname' => $parsed[6][0],
      'source' => $parsed[7][0],
      'message' => $parsed[8][0]
     ));

     if (
      count($judge) == 3 && 
      isset($judge['level']) &&
      isset($judge['name']) &&
      isset($judge['description'])
     ) {
      if (DEBUG) debug(__FUNCTION__.'() $judge', $judge);
      if ($judge['level'] >= TRIGGER)
       foreach ($output_handles as $output_handle)
        output(
         $output_handle, // needs & ?
         $callback,
         $judge['level'],
         $judge['name'],
         $judge['description']
        );
     } else
      trigger_error('Judge is malformed!', E_USER_WARNING);
    }
    break; // first matched exits?
   }
  }
 } else
  trigger_error('Logline is malformed (format mismatch)!', E_USER_WARNING);
}

function debug($label, $data) {
 if (is_array($data))
  echo 'DD '.$label.': '.print_r($data, TRUE)."\n";
 else
  echo 'DD '.$label.': '.trim($data)."\n";
}

function output_open($judgepipe) {
 // todo: implement this check for named pipes
 // if (file_exists($logpipe) || is_readable($logpipe)) 
 //  trigger_error('Check the logpipe please!', E_USER_ERROR);

 $handle = fopen($judgepipe, 'a+');
 if (!$handle)
  trigger_error('Serius problem opening the pipe for writing!', E_USER_ERROR);
 
 return $handle;
}

function output($handle, $callback, $level, $name, $description) {
 $data = time().'|'.urlencode($level).'|'.urlencode($callback).'|'.urlencode($name).'|'.urlencode($description)."\n";
 if (DEBUG) debug(__FUNCTION__.'() $data', $data);

 if (fwrite($handle, $data) === FALSE) 
  trigger_error('Serius problem writing to the pipe!', E_USER_ERROR);
}

function output_close($handle) {
 fclose($handle);
}

?>
